package de.mbutscher.wikiandpad;

import de.mbutscher.wikiandpad.alphabeta.R;
import de.mbutscher.wikiandpad.utils.ui.ActivityGuiHelper;
import android.app.Activity;
import android.content.pm.PackageManager.NameNotFoundException;
import android.os.Bundle;
import android.widget.TextView;

/**
 * Just shows an about dialog
 * @author Michael Butscher
 *
 */
public class AboutActivity extends Activity {
    
    protected ActivityGuiHelper<AboutActivity> guiHelper;


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        setContentView(R.layout.about_dlg);
        // Doesn't work:
        // getWindow().setFeatureInt(Window.FEATURE_NO_TITLE, 1);
        
        guiHelper = new ActivityGuiHelper<AboutActivity>(this);
        guiHelper.setOnClickListener(R.id.btnOk, "onCmdOk");
        
        TextView tvAbout = (TextView) findViewById(R.id.tvInfo);
        
        String version;
        try
        {
            version = this.getPackageManager().getPackageInfo(
                    this.getPackageName(), 0).versionName;
        }
        catch (NameNotFoundException e)
        {
            version = "<unknown>";
        }
        
        tvAbout.setText("WikiAndPad\nVersion: " + version + "\n\n" +
                    getString(R.string.copyright));
    }
    
    
    public void onCmdOk() {
        finish();
    }


}
