package de.mbutscher.wikiandpad;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import de.mbutscher.wikiandpad.db.MatchTermEntry;

/**
 Container to hold data of a search or replace operation. At the moment 
 only a simple search operation is supported. Public fields can be
 changed directly but call {@link #prepare()} after change.
 
 * @author Michael Butscher
 *
 */
public class SearchAndReplaceOperation {
    public String searchStr = "";
    
    protected Pattern compRe = null;
    
    public static class SearchHit {
        public int firstChar;
        public int afterLastChar;

        public SearchHit(int firstChar, int afterLastChar) {
            super();
            this.firstChar = firstChar;
            this.afterLastChar = afterLastChar;
        }
    }
    
    /**
     * Prepare cache information after change of fields 
     */
    public void prepare() {
        compRe = Pattern.compile(Pattern.quote(searchStr),
                Pattern.CASE_INSENSITIVE);
        
    }
    
    
    public MatchTermEntry searchText(String text, int searchCharStartPos) {
        if (compRe == null)
            return null;
        
        Matcher m = compRe.matcher(text);
        if (!m.find(searchCharStartPos))
            return null;
        
        return new MatchTermEntry(m.start(), m.end() - m.start());
    }
    
    /*
    public List<MatchTermEntry> searchAll(String text, int searchCharStartPos) {
        ArrayList<MatchTermEntry> result = new ArrayList<MatchTermEntry>();
        
        if (compRe == null)
            return result;
        
        

    }
    */

}
