package de.mbutscher.wikiandpad.db;

public class DbConsts {

    // Types of wikiword match terms (some can be binary or'ed together)

    /** Explicit alias (by "alias" attribute). */
    public static final int WIKIWORDMATCHTERMS_TYPE_EXPLICIT_ALIAS = 1;
    /** When trying to resolve links, look at this, too. */
    public static final int WIKIWORDMATCHTERMS_TYPE_ASLINK = 2;


    // The following four cannot be combined

    /** Bitmask to filter out following three */
    public static final int WIKIWORDMATCHTERMS_TYPE_FROM_MASK = 12;
    /** Matchterm was created based on the wiki word itself */
    public static final int WIKIWORDMATCHTERMS_TYPE_FROM_WORD = 0;
    /** Matchterm was created based on attributes(=properties) of the page or
    the wiki word  */
    public static final int WIKIWORDMATCHTERMS_TYPE_FROM_ATTRIBUTES = 4;
    /** Matchterm was created based on content of the page or one of the above */
    public static final int WIKIWORDMATCHTERMS_TYPE_FROM_CONTENT = 8;


    /** Matchterm will be created and deleted synchronously (normally in main thread)
    to ensure it is always up-to-date */
    public static final int WIKIWORDMATCHTERMS_TYPE_SYNCUPDATE = 16;



}
