package de.mbutscher.wikiandpad.db;

import android.os.Bundle;

public class MatchTermEntry {
    public String matchterm;
    public int type;
    public String wikiPageName;
    public int firstcharpos;
    public int charlength;
    public double visited;

    
    public MatchTermEntry(String matchterm, int type, String wikiPageName,
            int firstcharpos, int charlength, double visited) {
        set(matchterm, type, wikiPageName, firstcharpos, charlength, visited);
    }
    
    /** Reduced variant for results of in-page searches. */
    public MatchTermEntry(int firstcharpos, int charlength) {
        this(null, 0, null, firstcharpos, charlength, 0.0);
    }
    
    public MatchTermEntry(Bundle bundle) {
        matchterm = bundle.getString("matchterm");
        type = bundle.getInt("type");
        wikiPageName = bundle.getString("wikiPageName");
        firstcharpos = bundle.getInt("firstcharpos");
        charlength = bundle.getInt("charlength");
        visited = bundle.getDouble("visited");
    }
    
    /*
    public MatchTermEntry(MatchTermEntry mte) {
        this.matchterm = mte.matchterm;
        this.type = mte.type;
        this.wikiPageName = mte.wikiPageName;
        this.firstcharpos = mte.firstcharpos;
        this.charlength = mte.charlength;
        this.visited = mte.visited;
    }
    */

    public Bundle toBundle() {
        Bundle result = new Bundle(6);
        result.putString("matchterm", matchterm);
        result.putInt("type", type);
        result.putString("wikiPageName", wikiPageName);
        result.putInt("firstcharpos", firstcharpos);
        result.putInt("charlength", charlength);
        result.putDouble("visited", visited);
        
        return result;
    }


    public MatchTermEntry(Object[] eArray) {
        double visited;
        
        if (eArray.length > 5)
            visited = (Double) eArray[5];
        else
            visited = 0;
        
        set((String) eArray[0], (int)(long)(Long) eArray[1], (String) eArray[2],
                (int)(long)(Long) eArray[3], (int)(long)(Long) eArray[4],
                visited);
    }
    
    protected void set(String matchterm, int type, String wikiPageName,
            int firstcharpos, int charlength, double visited) {
        this.matchterm = matchterm;
        this.type = type;
        this.wikiPageName = wikiPageName;
        this.firstcharpos = firstcharpos;
        this.charlength = charlength;
        this.visited = visited;
    }
}