package de.mbutscher.wikiandpad.defaultwikilang;

import de.mbutscher.wikiandpad.WikiPage;
import de.mbutscher.wikiandpad.defaultwikilang.WikiLinkPath
        .PrefixSilenceAndPageName;

public class WikiLangHelper {


    /**
     * If using subpages this is used to resolve a link to the right wiki word
        for autocompletion. It returns a tuple (prefix, silence, pageName).
        Autocompletion now searches for all wiki words starting with pageName. For
        all found items it removes the first  silence  characters, prepends the  prefix
        instead and uses the result as suggestion for autocompletion.
     * @param link
     * @param basePage
     */
    public static PrefixSilenceAndPageName resolvePrefixSilenceAndWikiWordLink(
            String link, WikiPage basePage) {

        WikiLinkPath linkPath = new WikiLinkPath(link, null, -1, null);
        if (linkPath.isAbsolute())
            return linkPath.resolvePrefixSilenceAndWikiWordLink(null);

        if (basePage == null)
            return new PrefixSilenceAndPageName("", 0, link);  // TODO:  Better reaction?
        
        String basePageName = basePage.getWikiPageName();
        if (basePageName == null)
            return new PrefixSilenceAndPageName("", 0, link);  // TODO:  Better reaction?
        
        return linkPath.resolvePrefixSilenceAndWikiWordLink(new WikiLinkPath(
                null, basePageName, -1, null));
    }

}




/*

    def resolvePrefixSilenceAndWikiWordLink(link, basePage):
        """
        
        
        If prefix is None autocompletion is not possible.
        """
        linkPath = _WikiLinkPath(link=link)
        if linkPath.isAbsolute():
            return linkPath.resolvePrefixSilenceAndWikiWordLink(None)

        if basePage is None:
            return u"", 0, link  # TODO:  Better reaction?
        
        basePageName = basePage.getWikiWord()
        if basePageName is None:
            return u"", 0, link  # TODO:  Better reaction?
        
        return linkPath.resolvePrefixSilenceAndWikiWordLink(_WikiLinkPath(
                pageName=basePageName))


*/