package de.mbutscher.wikiandpad.defaultwikilang;

import java.util.ArrayList;
import java.util.HashMap;

import de.mbutscher.wikiandpad.WikiPage;
import de.mbutscher.wikiandpad.parsing.ParseException;
import de.mbutscher.wikiandpad.parsing.SyntaxNode;
import de.mbutscher.wikiandpad.utils.HashMapBuilder;
import de.mbutscher.wikiandpad.utils.NotCurrentThreadException;
import de.mbutscher.wikiandpad.utils.ThreadStop;

public class WikiLangParser {

    protected static HashMap<String, Object> _buildBaseDict() {
        // TODO Auto-generated method stub
        return (new HashMapBuilder<String, Object>())
                .put("indentInfo", "normal")
                .getHashMap();
        
        /*
        
        def _buildBaseDict(wikiDocument=None, formatDetails=None):
            if formatDetails is None:
                if wikiDocument is None:
                    formatDetails = WikiDocument.getUserDefaultWikiPageFormatDetails()
                    formatDetails.setWikiLanguageDetails(WikiLanguageDetails(None, None))
                else:
                    formatDetails = wikiDocument.getWikiDefaultWikiPageFormatDetails()
        
            return {"indentInfo": IndentInfo("normal"),
                    "wikiFormatDetails": formatDetails
        }
    
    
        */
    }

    protected static SyntaxNode _postProcessing(String content,
            SyntaxNode pageAst, ThreadStop threadStop) {
        return pageAst;
    }
    
    /**
     * Parse the  content  written in wiki language  intLanguageName  using
        formatDetails  and regularly call  threadstop.testRunning()  to
        raise exception if execution thread is no longer current parsing
        thread.
     * @param content
     * @return
     * @throws NotCurrentThreadException 
     */
    public static SyntaxNode parseText(String content, WikiPage basePage,
            ThreadStop threadStop) throws NotCurrentThreadException {
        
        // TODO: formatDetails
        
        if (content.length() == 0) {
            return SyntaxNode.buildSyntaxNode(new ArrayList<SyntaxNode>(), 0,
                    "text");
        }
        
        /*
        
        if formatDetails.noFormat:
            return buildSyntaxNode([buildSyntaxNode(content, 0, "plainText")],
                    0, "text")
        
        */
        
        HashMap<String, Object> baseDict = _buildBaseDict();
        
        baseDict.put("baseWikiPage", basePage);
        
        
        try {
            SyntaxNode t = SyntaxNode.buildSyntaxNode(
                    ParserGrammar.getTextParserElement()
                    .parseString(content, true, baseDict, threadStop), 0,
                    "text");

            return _postProcessing(content, t, threadStop);
        } catch (ParseException e) {
            throw new RuntimeException(
                    "Internal error: Couldn't parse wiki page", e);
        }
        
    }
}



/*


    @staticmethod
    def parse(intLanguageName, content, formatDetails, threadstop):

        if len(content) == 0:
            return buildSyntaxNode([], 0, "text")

        if formatDetails.noFormat:
            return buildSyntaxNode([buildSyntaxNode(content, 0, "plainText")],
                    0, "text")

        baseDict = _buildBaseDict(formatDetails=formatDetails)

##         _prof.start()
        try:
            t = text.parseString(content, parseAll=True, baseDict=baseDict,
                    threadstop=threadstop)
            t = buildSyntaxNode(t, 0, "text")

            t = _TheParser._postProcessing(intLanguageName, content, formatDetails,
                    t, threadstop)

        finally:
##             _prof.stop()
            pass

        return t




*/






