package de.mbutscher.wikiandpad.parsing;

import de.mbutscher.wikiandpad.utils.NotCurrentThreadException;

    /**
     * Lookahead matching of the given parse expression.  FollowedBy
    does *not* advance the parsing position within the input string, it only
    verifies that the specified parse expression matches at the current
    position.  FollowedBy always returns a null token list.
     */
public class FollowedBy extends ParseElementEnhance {

    public FollowedBy(ParserElement expr) {
        super(expr);
        mayReturnEmpty = true;
    }
    
    @Override
    protected ParsingResult parseImpl(String instring, int loc,
            ParsingState state, boolean doActions) throws ParseException,
            NotCurrentThreadException {
        expr.tryParse(instring, loc, state);
        return new ParsingResult(loc);
    }

}
