package de.mbutscher.wikiandpad.parsing;


/**
 * base exception class for all parsing runtime exceptions
 *
 */
@SuppressWarnings("serial")
public class ParseBaseException extends Exception {
    protected String pstr;
    protected String msg;
    protected int loc;
    protected ParserElement parserElement;

    public ParseBaseException(String pstr, int loc, String msg, ParserElement parserElement) {
        if (msg == null) {
            this.msg = pstr;
            this.pstr = "";
        }
        else {
            this.msg = msg;
            this.pstr = pstr;
        }

        this.loc = loc;
        this.parserElement = parserElement;
    }

    public String getPstr() {
        return pstr;
    }

    public int getLoc() {
        return loc;
    }

    public String getMsg() {
        return msg;
    }

    public ParserElement getParserElement() {
        return parserElement;
    }
}
