package de.mbutscher.wikiandpad.parsing;

import de.mbutscher.wikiandpad.utils.NotCurrentThreadException;

public class ParseElementEnhance extends ParserElement {

    protected ParserElement expr;

    public ParseElementEnhance(ParserElement expr) {
        super();
        this.expr = expr;
        if (expr != null) {
            this.mayIndexError = expr.mayIndexError;
            this.mayReturnEmpty = expr.mayReturnEmpty;
            
        }
    }

    @Override
    protected ParsingResult parseImpl(String instring, int loc,
            ParsingState state, boolean doActions) throws ParseException,
            NotCurrentThreadException {
        if (expr != null)
            return expr.parse(instring, loc, state, doActions);
        else
            throw new ParseException(String.format(
                    "ParseElementEnhance expr is null %s", this),
                    loc,
                    String.format("ParseElementEnhance expr is null %s", this),
                    this);
    }
    
    @Override
    public ParserElement streamline() {
        super.streamline();
        if (expr != null)
            expr.streamline();

        return this;
    }

    
    @Override
    protected void _optimizeSub(OptimizerOptions options) {
        if (expr != null)
            expr = expr._realOptimize(options);
    }

    
    @Override
    public String toString() {
        if (expr != null)
            return String.format("%s:(%s)", getClass().getName(), expr);
        else
            return String.format("%s:(null)", getClass().getName());
    }
}
