package de.mbutscher.wikiandpad.parsing;

import java.util.Arrays;
import java.util.List;

import de.mbutscher.wikiandpad.utils.StringOps;

/**
 * Returned by parse() methods.
 * All member variables can be accessed directly.
 * 
 * @author Michael Butscher
 *
 */
public class ParseProcessingData extends BaseParsingProduct {
    public int tokensStart;
    public String resultsName;


    public ParseProcessingData(List<SyntaxNode> retTokens, int tokensStart,
            String resultsName) {
        super(retTokens);
        this.tokensStart = tokensStart;
        this.resultsName = resultsName;
    }


    public ParseProcessingData(SyntaxNode syntaxNode, int tokensStart,
            String resultsName) {
        super(syntaxNode);
        this.tokensStart = tokensStart;
        this.resultsName = resultsName;
    }


    /**
     * Necessary to resolve ambiguity because NonTerminalNode implements
     * List&lt;SyntaxNode&gt;
     */
    public ParseProcessingData(NonTerminalNode syntaxNode, int tokensStart,
            String resultsName) {
        this((SyntaxNode) syntaxNode, tokensStart, resultsName);
    }

    
    public ParseProcessingData(List<SyntaxNode> retTokens, int tokensStart) {
        this(retTokens, tokensStart, null);
    }
    
    public ParseProcessingData(SyntaxNode syntaxNode, int tokensStart) {
        this(syntaxNode, tokensStart, null);
    }

    public ParseProcessingData() {
        this(null, -1, null);
    }
    
    public void encapsulateIfNeeded() {
        if (!fromSingleNode && StringOps.notEmpty(resultsName)) {
            retTokens = Arrays.asList((SyntaxNode) SyntaxNode.buildSyntaxNode(
                    retTokens, tokensStart, resultsName));
        }
        resultsName = null;
    }

    
    
    
    
    

    /* public ParsingResult toParsingResult(int nextLoc) {
        
        return new ParsingResult()
    }

    
    
    
    
    
    
    /*
    public ParseProcessingData(int nextLoc) {
        this(nextLoc, EMPTYLIST);
    }

    public ParseProcessingData() {
        this(-1, EMPTYLIST);
    }

    public ParsingResult(List<SyntaxNode> retTokens) {
        this(-1, retTokens);
    }

    public ParsingResult(SyntaxNode syntaxNode) {
        this(-1, syntaxNode);
    }
    */

}
