package de.mbutscher.wikiandpad.parsing;

import java.util.Map;

public interface StackedDict<K, V> {

    public abstract Map<K, V> getTopDict();

    /**
     * Same as {@link #getTopDict()}
     */
    public abstract Map<K, V> peek();

    public abstract Map<K, V> getSubTopDict();

    public abstract Map<K, V> getNamedDict(String name);

    /**
     *  Push new dictionary on stack, normally a copy of previous top stack dict.
        For convenience it returns the new stack top dict.
     * @param newName
     * @param newDict
     * @return
     */
    public abstract Map<K, V> push(String newName, Map<K, V> newDict);
    public abstract Map<K, V> push(String newName);

    public abstract Map<K, V> pop();

    // Implement parts of Map interface
    public abstract boolean containsKey(Object key);

    public abstract V get(Object key);

    public abstract V put(K key, V value);

    public abstract V remove(Object key);


}