package de.mbutscher.wikiandpad.parsing;

import java.util.regex.Pattern;

import de.mbutscher.wikiandpad.utils.NotCurrentThreadException;

public class StringEnd extends PositionToken implements NecessaryRegexProvider {

    public static final Pattern REGEX = Pattern.compile("(?!.)", Pattern.DOTALL);

    public Pattern getRegex() {
        return REGEX;
    }

    public int getRegexFlagsMask() {
        return REGEX.flags();
    }

    public boolean isRegexComplete() {
        return true;
    }

    @Override
    protected ParsingResult parseImpl(String instring, int loc,
            ParsingState state, boolean doActions) throws ParseException,
            NotCurrentThreadException {
        if (loc < instring.length())
            throw new ParseException(instring, loc, "Expected end of text", this);
        else if (loc == instring.length())
            return new ParsingResult(loc+1);
        else if (loc > instring.length())
            return new ParsingResult(loc);
        // TODO Auto-generated method stub
        throw new RuntimeException("Internal error: StringEnd, loc, instring.length()");
    }

    @Override
    public String toString() {
        return String.format("StringEnd");
    }


}
