package de.mbutscher.wikiandpad.parsing;

import java.util.ArrayList;
import java.util.List;

import de.mbutscher.wikiandpad.utils.StringOps;

public class TerminalNode extends SyntaxNode {

    protected String text;
    
    public TerminalNode(String text, int pos, String name) {
        super(pos, name);
        this.text = text;
        // TODO Auto-generated constructor stub
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    @Override
    public boolean isTerminal() {
        return true;
    }

    @Override
    public List<SyntaxNode> asList() {
        ArrayList<SyntaxNode> result = new ArrayList<SyntaxNode>();
        result.add(this);
        return result;
    }

    @Override
    public NonTerminalNode asNonTerminal() {
        return new NonTerminalNode(asList(), getPos(), "");
    }

    @Override
    public List<String> asStringList(String sep) {
        ArrayList<String> result = new ArrayList<String>();
        result.add(getText());
        return result;
    }

    @Override
    public String getString() {
        return getText();
    }
    
    @Override
    public TerminalNode getFirstToken() {
        return this;
    }

    @Override
    public void recalcStrLength() {
        strLength = getText().length();
    }

    @Override
    public List<SyntaxNode> findNodesForCharPos(int charPos) {
        ArrayList<SyntaxNode> result = new ArrayList<SyntaxNode>();
        
        if (charPos < getPos() || charPos >= (getPos() + getStrLength())) 
            return result; // empty list
        
        result.add(this);
        return result;
    }

    @Override
    protected void pprintRecurs(int ind, int inc, StringBuilder result) {
        result.append(StringOps.multiply(" ", ind) + String.format(
                "TNode(%s, %s, '%s', %s ", pos,  getStrLength(), name,
                pprintDict()));

        result.append(String.format("\"%s\")", getText()));
    }

}
