package de.mbutscher.wikiandpad.utils;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;

/**
 * Incomplete implementation
 * @author Michael Butscher
 *
 * @param <E>
 */
public class IdentityWeakArrayList<E> implements List<E> {

    protected ArrayList<WeakReference<E>> data;
    
    protected boolean compactionNeeded;

    
    public IdentityWeakArrayList() {
        data = new ArrayList<WeakReference<E>>();
        compactionNeeded = false;
    }

    public void add(int index, E object) {
        data.add(index, new WeakReference<E>(object));
    }

    public boolean add(E object) {
        return data.add(new WeakReference<E>(object));
    }

    public boolean addAll(Collection<? extends E> collection) {
        for (E item: collection)
            add(item);
        
        return true;
    }

    public boolean addAll(int index,
            Collection<? extends E> collection) {
        throw new UnsupportedOperationException();
        // return data.addAll(index, collection);
    }

    public void clear() {
        data.clear();
    }

    @Override
    @SuppressWarnings("unchecked")
    public Object clone() {
        IdentityWeakArrayList<E> result = new IdentityWeakArrayList<E>();
        result.data = (ArrayList<WeakReference<E>>) data.clone();
        return result;
    }

    public boolean contains(Object object) {
        return indexOf(object) != -1;
    }

    public boolean containsAll(Collection<?> collection) {
        for (Object item: collection) {
            if (!contains(item))
                return false;
        }

        return true;
    }

    public void ensureCapacity(int minimumCapacity) {
        data.ensureCapacity(minimumCapacity);
    }

    @Override
    public boolean equals(Object o) {
        if (o == null)
            return false;
        
        if (!(o instanceof IdentityWeakArrayList))
            return false;
        
        @SuppressWarnings("unchecked")
        IdentityWeakArrayList<E> otherList = (IdentityWeakArrayList<E>) o;
        
        if (size() != otherList.size())
            return false;
        
        for(int i = 0; i < size(); ++i) {
            if (get(i) != otherList.get(i))
                return false;
        }

        return true;
    }

    public E get(int index) {
        WeakReference<E> itemRef = data.get(index);
        if (itemRef == null)
            return null;
        
        E item = itemRef.get();
        if (item == null)
            compactionNeeded = true;

        return item;
    }

    @Override
    public int hashCode() {
        // TODO: Better idea?
        return data.hashCode();
    }

    public int indexOf(Object object) {
        for(int i = 0; i < size(); ++i) {
            if (get(i) == object)
                return i;
        }
        return -1;
    }

    public int lastIndexOf(Object object) {
        for(int i = size() - 1; i >= 0; --i) {
            if (get(i) == object)
                return i;
        }
        return -1;
    }

    public boolean isEmpty() {
        return data.isEmpty();
    }

    public Iterator<E> iterator() {
        throw new UnsupportedOperationException();
        // return data.iterator();
    }

    public ListIterator<E> listIterator() {
        throw new UnsupportedOperationException();
        // return data.listIterator();
    }

    public ListIterator<E> listIterator(int location) {
        throw new UnsupportedOperationException();
        // return data.listIterator(location);
    }

    public E remove(int index) {
        E oldItem = get(index);
        data.remove(index);
        return oldItem;
    }

    public boolean remove(Object object) {
        return data.remove(object);
    }

    public boolean removeAll(Collection<?> collection) {
        throw new UnsupportedOperationException();
        // return data.removeAll(collection);
    }

    public boolean retainAll(Collection<?> collection) {
        throw new UnsupportedOperationException();
        // return data.retainAll(collection);
    }

    public E set(int index, E object) {
        E oldItem = get(index);
        data.set(index, new WeakReference<E>(object));
        return oldItem;
    }

    public int size() {
        return data.size();
    }

    public List<E> subList(int start, int end) {
        throw new UnsupportedOperationException();
    }

    public Object[] toArray() {
        throw new UnsupportedOperationException();
        // return data.toArray();
    }

    public <T> T[] toArray(T[] contents) {
        throw new UnsupportedOperationException();
        // return data.toArray(contents);
    }

    @Override
    public String toString() {
        throw new UnsupportedOperationException();
        // return data.toString();
    }

    public void trimToSize() {
        data.trimToSize();
    }

    
    public boolean getCompactionNeeded() {
        return compactionNeeded;
    }

    public void setCompactionNeeded(boolean compactionNeeded) {
        this.compactionNeeded = compactionNeeded;
    }

    public synchronized void compactify() {
        if (!compactionNeeded)
            return;
        
        ArrayList<WeakReference<E>> newData =
                new ArrayList<WeakReference<E>>();
        
        for(WeakReference<E> itemRef: data) {
            if (itemRef != null && itemRef.get() != null)
                newData.add(itemRef);
        }
        data = newData;
        compactionNeeded = false;
    }


    

}
