package de.mbutscher.wikiandpad.utils.ui;

import android.app.Activity;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ListView;

public class FragmentGuiHelper<AC extends Activity, FC extends Fragment>
        extends AbstractGuiHelper<AC>{

    protected FC fragment;
    protected int contentViewLayoutResId = -1; // TODO: Is -1 really invalid?
    protected View contentView = null;

    public FragmentGuiHelper(FC fragment) {
        this.fragment = fragment;
    }


    @SuppressWarnings("unchecked")
    @Override
    public <T extends AC> T getActivity() {
        return (T) fragment.getActivity();
    }

    
    public View handleOnCreateView(LayoutInflater inflater,
            ViewGroup container, Bundle savedInstanceState) {
        if (contentViewLayoutResId != -1) {
            contentView = inflater.inflate(contentViewLayoutResId, container,
                    false);
            contentViewLayoutResId = -1;
            return contentView;
        }
        
        return contentView;
    }
    
    public void setContentView(int layoutResID) {
        contentViewLayoutResId = layoutResID;
    }

    public void setContentView(int layoutResID, LayoutInflater inflater,
            ViewGroup container, Bundle savedInstanceState) {
        contentViewLayoutResId = layoutResID;
        handleOnCreateView(inflater, container, savedInstanceState);
    }
    
    public View getContentView() {
        return contentView;
    }
    
    public ListView getListView() {
        return findViewById(android.R.id.list);
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends View> T findViewById(int id) {
        if (contentView == null)
            return super.findViewById(id);
        else {
            return (T) contentView.findViewById(id);
        }
    }
    
    public void setOnClickListener(int id, String listenerMethodName) {
        setOnClickListener(fragment, findViewById(id),
                listenerMethodName);
    }


}

